/*
pong384_2_player		by PPs
started:	16.07.2022
finished:	24.07.2022
*/

	icl 'atari.hea'

BEGIN	equ $2000

pmg	equ $3000
m0	equ pmg+$180
p0	equ m0+128
p1	equ p0+128
p2	equ p1+128
riball	equ $80
hpos	equ $81
hpos1	equ $82
yball	equ $83
xball	equ $84
yyball	equ $85

	org BEGIN
;------------
	.proc main
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	mva #@dmactl(standard|dma|players|missiles|lineX2) 559
	mva #$40 hposp0
	sta hpos
	sta hpos1
	mva #$b8 hposp1
	lda #14
	sta 704
	sta 705
	sta 706
	ldy #2
	mva #16 (88),y
	ldy #37
	sta (88),y
	ldy #$7f
	lda #$80
	sta hposp2
@	sta p2,y
	dey
	bpl @-
@	lda ptrig0
	bne @-
	jmp newball.first
mainloop
	jsr yy_ball
	lda 20
@	cmp 20
	beq @-
;paddles
	lda paddle0
	cmp #102
	bcs nochange
	cmp #16
	bcc nochange
	sta hpos
nochange
	lda paddle1
	cmp #102
	bcs nochange2
	cmp #16
	bcc nochange2
	sta hpos1
nochange2
;clear player 0+1
	lda #0
	ldx #$ff
@	sta p0,x
	dex
	bne @-
;player0
	ldy hpos
	lda #$f0
	ldx #10
@	sta p0,y
	iny
	dex
	bpl @-
;player0 end
;player1
	ldy hpos1
	lda #$0f
	ldx #10
@	sta p1,y
	iny
	dex
	bpl @-
;player1 end
;ball
	lda riball
	beq decrement
;increment
;collusion
	lda kolm0p
	beq nix
	cmp #%00000010
	bne @+
	lda #0
	sta riball
	sta hitclr
	lda hpos1
	jsr changeri
	jmp nix
;collusion end
@	sta hitclr
nix	inc xball
w	ldy #2
	lda xball
	sta hposm0
	beq newball
	jmp mainloop
decrement
;collusion
	lda kolm0p
	beq nix1
	cmp #%00000001
	bne @+
	lda #1
	sta riball
	sta hitclr
	lda hpos
	jsr changeri
	jmp nix1
;collusion end
@	sta hitclr
nix1	dec xball
w1	ldy #37
	lda xball
	sta hposm0
	beq newball
	jmp mainloop
;ball ypos end
	.endp
;------------
	.proc changeri
	add #5
	cmp yball
	beq straight
	bcc up
;down
	mva #2 yyball
	rts
up
	mva #1 yyball
	rts
straight
	mva #0 yyball
	rts
	.endp
;------------
	.proc newball
	lda (88),y
	add #1
	sta (88),y
	cmp #16+9	;9?
	beq win
first
;ball richtung
@	lda random
	cmp #3
	bcs @-
	sta yyball
;new ball pos
@	ldy random
	cpy #16
	bcc @-
	cpy #110
	bcs @-
	sty yball
	jsr paintball
	jmp main.mainloop
	.endp
;------------
	.proc win
	mva #0 710
	lda 19
@	cmp 19
	beq @-
	jmp $e477
	.endp
;------------
	.proc yy_ball
;ball ypos
	lda yyball
	beq paintb
	cmp #1
	beq runter
hoch
	dec yball
	lda yball
	cmp #16
	beq chgru
	jmp paintb
chgru
	mva #1 yyball
paintb
	jsr paintball
	rts
runter
	inc yball
	lda yball
	cmp #110
	beq chgho
	jmp paintb
chgho
	mva #2 yyball
	jmp paintb
	.endp
;------------
	.proc paintball
	lda #0
	ldy #111
@	sta m0,y
	dey
	bpl @-
	ldy yball
	lda #$3
	sta m0,y
	sta m0+1,y
	rts
	.endp
;------------
	run main