/*
pong512		by PPs
started:	16.07.2022
finished:	24.07.2022
*/

	icl 'atari.hea'

BEGIN	equ $2000

pmg	equ $3000
m0	equ pmg+$180
p0	equ m0+128
p1	equ p0+128
p2	equ p1+128
riball	equ $80
hpos	equ $81
hpos1	equ $82
yball	equ $83
xball	equ $84
yyball	equ $85

	org BEGIN
;------------
	.proc main
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	sta skctl
	mva #0 audctl
	mva #@dmactl(standard|dma|players|missiles|lineX2) 559
	mva #$40 hposp0
	sta hpos
	sta hpos1
	mva #$b8 hposp1
	lda #14
	sta 704
	sta 705
	sta 706
	sta hitclr
	ldy #2
	mva #16 (88),y
	ldy #37
	sta (88),y
	ldy #$7f
	lda #$80
	sta hposp2
@	sta p2,y
	dey
	bpl @-
.local startloop
	lda 20
@	cmp 20
	beq @-
	lda paddle0
	cmp #102
	bcs nochange
	cmp #16
	bcc nochange
	sta hpos
nochange
	jsr player	
	lda ptrig0
	bne startloop
.endl
	jmp newball.first
mainloop
	jsr yy_ball
	lda 20
@	cmp 20
	beq @-
	sta 706
	lda #0
	sta audc1
	sta audf1
	lda paddle0
	cmp #102
	bcs nochange
	cmp #16
	bcc nochange
	sta hpos
nochange
	lda yball
	add #8
diff	sbc #4
	cmp #102
	bcc w0
	lda #102
	jmp @+
w0	cmp #16
	bcs @+
	lda #16
@	sta hpos1
	jsr player
;ball
	lda riball
	beq decrement
;increment
;collusion
	lda kolm0p
	beq nix
	cmp #%00000010
	bne @+
	lda #0
	sta riball
	sta hitclr
	lda hpos1
	jsr changeri
	mva #%10100011 audc1
	mva #53 audf1
	jmp nix
;collusion end
@	sta hitclr
nix	inc xball
w	ldy #2
	lda xball
	sta hposm0
	beq newball
	jmp mainloop
decrement
;collusion
	lda kolm0p
	beq nix1
	cmp #%00000001
	bne @+
	lda #1
	sta riball
	sta hitclr
	lda hpos
	jsr changeri
	mva #%10100011 audc1
	mva #53 audf1
	jmp nix1
;collusion end
@	sta hitclr
nix1	dec xball
w1	ldy #37
	lda xball
	sta hposm0
	beq newball
	jmp mainloop
;ball ypos end
	.endp
;------------
	.proc changeri
	add #4
	cmp yball
	beq straight
	bcc up
	add #2
	cmp yball
	bcc straight
;down
	mva #2 yyball
	rts
up
	mva #1 yyball
	rts
straight
	mva #0 yyball
	rts
	.endp
;------------
	.proc newball
	mvx #%11000011 audc1
	mvx #53 audf1
	mva #$fb 20
@	lda 20
	bne @-
	lda (88),y
	add #1
	sta (88),y
	cmp #16+9	;9?
	beq win
first
;ball richtung
@	lda random
	cmp #3
	bcs @-
	sta yyball
;new ball pos
@	ldy random
	cpy #16
	bcc @-
	cpy #110
	bcs @-
	sty yball
	jsr paintball
	jmp main.mainloop
	.endp
;------------
	.proc win
	mva #0 710
	ldx #1
lx	lda 19
@	cmp 19
	beq @-
	dex
	bpl lx
	jmp $e477
	.endp
;------------
	.proc yy_ball
;ball ypos
	lda yyball
	cmp #1
	beq runter
	cmp #2
	bne paintb
hoch
	dec yball
	lda yball
	cmp #16
	beq chgru
	jmp paintb
chgru
	mva #1 yyball
	jsr spd
paintb
	jsr paintball
	rts
runter
	inc yball
	lda yball
	cmp #110
	beq chgho
	jmp paintb
chgho
	mva #2 yyball
	jsr spd
	jmp paintb
	.endp
;------------
	.proc spd
;chg cpu speed
@	lda random
	cmp #21
	bcs @-
	sta main.diff+1
	rts
	.endp
;------------
	.proc paintball
	lda #0
	ldy #111
@	sta m0,y
	dey
	bpl @-
	ldy yball
	lda #$3
	sta m0,y
	sta m0+1,y
	rts
	.endp
;------------
	.proc player
;clear player 0+1
	lda #0
	ldx #$ff
@	sta p0,x
	dex
	bne @-
;player0
	ldy hpos
	lda #$f0
	ldx #10
@	sta p0,y
	iny
	dex
	bpl @-
;player0 end
;player1
	ldy hpos1
	lda #$0f
	ldx #10
@	sta p1,y
	iny
	dex
	bpl @-
;player1 end
	rts
	.endp
;------------
	run main
